﻿-- JSON.SQL
-- Pas besoin d'extension
Drop Table If Exists tUtiliseJSON ;

-- Création de la table
Create Table tUtiliseJSON (
	iId serial Constraint tUtiliseJSON_pk PRIMARY KEY
	, jValeurJSON JSON
	) ;

-- Insertion de données
INSERT INTO tUtiliseJSON (jValeurJSON) VALUES
	('{"Nom": "Rencontres AtoutBox"
		, "Début": "15 mars 2018"
		, "Fin": "16 mars 2018"
		, "URL": "http://www.atoutfox.org/dates_rencontres_atoutfox_2018-programme.asp"
		}') ;

-- Données multidimensionnelles
INSERT INTO tUtiliseJSON (jValeurJSON) VALUES
	('{"Nom": "Rencontres AtoutBox"
		, "Début": "15 mars 2018"
		, "Fin": "16 mars 2018"
		, "URL": "http://www.atoutfox.org/dates_rencontres_atoutfox_2018-programme.asp"
		, "Sessions": [
			{"Titre": "API vulgarisation", "Auteur": "Gregory ADAM"}
			, {"Titre": "VFP sur le WEB", "Auteur": "Gilles LAJOT-SARTHOU"}
			, {"Titre": "noSQL en VFP", "Auteur": "Luc GILOT"}
			]
		}') ;

-- Vérification de la syntaxe JSON
-- INSERT INTO tUtiliseJSON (jValeurJSON) VALUES
-- 	('{"Nom": "Rencontres AtoutBox"
-- 		, "Début": "15 mars 2018"
-- 		, "Fin": "16 mars 2018"
-- 		, "URL": "http://www.atoutfox.org/dates_rencontres_atoutfox_2018-programme.asp"
-- 		, "Sessions": [
-- 			{"Titre": "API vulgarisation", "Auteur": "Gregory ADAM"}
-- 			, {"Titre": "VFP sur le WEB", "Auteur": "Gilles LAJOT-SARTHOU"}
-- 			, "Titre": "noSQL en VFP", "Auteur": "Luc GILOT"}
-- 			]
-- 		}') ;

-- Lecture des données
Select * From  tUtiliseJSON ;
Select iId, jValeurJSON->'Nom' AS Nom, jValeurJSON->'Début' AS Début, jValeurJSON->'Fin' AS Fin From tUtiliseJSON ;

