* PurVFP.PRG
Set Default To "D:\Luc\Dev\Tlcharg et outils\AtoutFox Rencontres\2018\noSQL\VFP\"
Clear

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Table Oriente document
Close Databases all
Set Safety Off
Create DataBase noSQL
Create Table tOrienteColonne ( ;
	vCle V(50) Primary Key ;
	, mValeurJSON M ;
	)
Set Safety On

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Insertion d'un document "en dur"
Local lcDocument, lcCle
m.lcCle = Sys(2015)
Text To m.lcDocument Textmerge Noshow Pretext 1 + 2 + 4 + 8
	{"Id": "<<m.lcCle>>"
		, "Nom": "Rencontres AtoutBox"
		, "Dbut": "15 mars 2018"
		, "Fin": "16 mars 2018"
		, "URL": "http://www.atoutfox.org/dates_rencontres_atoutfox_2018-programme.asp"
		, "Sessions": [
			{"Titre": "API vulgarisation", "Auteur": "Gregory ADAM"}
			, {"Titre": "VFP sur le WEB", "Auteur": "Gilles LAJOT-SARTHOU"}
			, {"Titre": "noSQL en VFP", "Auteur": "Luc GILOT"}
		]
	}
Endtext

Insert Into tOrienteColonne (vCle, mValeurJSON) Values (m.lcCle, m.lcDocument)

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Lecture d'un document
Set Procedure To qdfoxjson.prg Additive 
Local loJSONHelper, loDocument
m.loJSONHelper = CreateObject("jsonHelper")
m.lojsonhelper.QuotePropertyNames = .T.
m.lojsonhelper.StringDelimitator = '"'
m.loDocument = m.loJSONHelper.Parse(m.lcDocument)

? "m.loDocument.Id = ", m.loDocument.Id
? "m.loDocument.Nom = ", m.loDocument.Nom
? "m.loDocument.Dbut = ", m.loDocument.Fin
Local loSession, liSession
m.liSession = 0
For Each loSession In m.loDocument.Sessions
	m.liSession = m.liSession + 1 
	? "Session N" + Transform(m.liSession)
	? "		m.loSession.Titre = ", m.loSession.Titre
	? "		m.loSession.Auteur = ", m.loSession.Auteur
EndFor

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Modification d'un document : modification de proprit simple
* Correction de l'orthographe de "AtoutBox"
m.loDocument.Nom = "Rencontres AtoutFox"
m.lcDocument = m.loJSONHelper.Encode(m.loDocument)
Update tOrienteColonne Set mValeurJSON = m.lcDocument Where vCle = m.lcCle
Browse 

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Modification d'un document : ajout de proprit simple
AddProperty(m.loDocument, "Lieu", "Hotel Ibis Lyon Perrache")
m.lcDocument = m.loJSONHelper.Encode(m.loDocument)
Update tOrienteColonne Set mValeurJSON = m.lcDocument Where vCle = m.lcCle
Browse 

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Modification d'un document : enlever une proprit
* Corection de l'orthographe de "AtoutBox"
RemoveProperty(m.loDocument, "Dbut")
m.lcDocument = m.loJSONHelper.Encode(m.loDocument)
m.lcDocument = Strtran(m.lcDocument, "%DOUBLEQUOTE%", '"')
m.lcDocument = Strtran(m.lcDocument, "%SINGLEQUOTE%", "'")
Update tOrienteColonne Set mValeurJSON = m.lcDocument Where vCle = m.lcCle
Browse 

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Modification d'un document : tableau
Local lcNouvelleSession, loNouvelleSession
m.lcNouvelleSession = [{"Titre": "Introduction  l'intelligence artificielle", "Auteur": "Jean-Claude RIVIRE"}]
m.loNouvelleSession = m.loJSONHelper.Parse(m.lcNouvelleSession)
m.loDocument.Sessions.Add(m.loNouvelleSession)
m.lcDocument = m.loJSONHelper.Encode(m.loDocument)
m.lcDocument = Strtran(m.lcDocument, "%DOUBLEQUOTE%", '"')
m.lcDocument = Strtran(m.lcDocument, "%SINGLEQUOTE%", "'")
Update tOrienteColonne Set mValeurJSON = m.lcDocument Where vCle = m.lcCle
Browse

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Rechercher dans le document
Locate For ["auteur":"Gregory ADAM"] $ mValeurJSON
MessageBox(Found())

Set Step On

