* JSONB2.PRG
* Renormalisation du JSONB par une vue VFP
Set Default To "D:\Luc\Dev\Tlcharg et outils\AtoutFox Rencontres\2018\noSQL\VFP\"
Clear
Close Databases all
Set Safety Off

Local lcCnxnString, liCnxnHndl, laErr[1], liResultat

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Se connecter  PG
m.lcCnxnString = [DRIVER={] + "PostgreSQL Unicode" + [};] ;
					+ [SERVER=]+ "127.0.0.1" +[;] ;
					+ [DATABASE=] + "AtoutFox_2018" +[;] ;
					+ [PORT=] + "5432" +[;] ;
					+ [UID=] + "AtoutFox" +[;] ;
					+ [PWD=] + "mdp" + [;] ;
					+ [B9=0]

m.liCnxnHndl = SQLStringConnect(m.lcCnxnString)
If m.liCnxnHndl <= 0
	AError(m.laErr)
	MessageBox("Echec de la connexion : " + m.laErr[1, 2])
	Return 
Else
	MessageBox("Connexion OK")
Endif

return



















* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Crer une vue renormalise
Open Database noSQL
Create Connection maConnexion Connstring m.lcCnxnString
Create Sql View vUtiliseJSONBNormalise ;
	Connection maConnexion ;
	AS SELECT iid ;
			, jValeurJSONB->>'Nom' As Nom ;
			, jValeurJSONB->>'Dbut' As Dbut ;
			, jValeurJSONB->>'Fin' As Fin ;
			, jValeurJSONB->>'URL' As URL ;
			, jValeurJSONB->>'Sessions' As Sessions ;
 		FROM tUtiliseJSONB ;
 		Where iId < 10

Use vUtiliseJSONBNormalise 
Browse

